-- 新祈福
checkRequire("Lua_rewardUtil");
Lua_BlessWindow  = class("Lua_BlessWindow", Lua_Window);
function Lua_BlessWindow:ctor(p)	
	self:superCall("ctor", self.list);

	self.windowName = "Lua_BlessWindow";
	self.skinName = "BlessWindow_skin";
end

function Lua_BlessWindow:buildShowItem(go)	
	self:superCall("buildShowItem");

	self.spArr = Array();
	self.middletime.text = "";

	self.rightredDot = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", 90, -182, 0, 0);
	self.rightredDot:setDepth(6)
	self.rightredDot:setEnable(false);

	self.leftmoney:setAltas("icon_atlas_3", "money_209000003");
	self.middlemoney:setAltas("icon_atlas_3", "money_209000003");
	self.rightmoney:setAltas("icon_atlas_3", "money_209000002");

	self.leftButton:addClickFuntion(self, self.leftClick);
	self.middleButton:addClickFuntion(self, self.rightClick);
	self.rightButton:addClickFuntion(self, self.onMingLiClick);

	self:addLuaEvent("BLESS_UPDATE", self, self.getBlessUpData);
	self:addLuaEvent("GETBLESSB_UPDATE", self, self.blessUpdata);
	DataCenter.QiandaoData:askBlessinfo();
end

function Lua_BlessWindow:getBlessUpData()
	self.exp_count =  DataCenter.QiandaoData.exp_count + 1;
	self.exp_total_count =  DataCenter.QiandaoData.exp_total_count;

	self.money_count =  DataCenter.QiandaoData.money_count + 1;
	self.money_total_count =  DataCenter.QiandaoData.money_total_count;
	self.money_time = DataCenter.QiandaoData.money_time;

	self.life_count = DataCenter.QiandaoData.life_count + 1; -- 命力已祈福次数
	self.life_total_count = DataCenter.QiandaoData.life_total_count; -- 命力总的祈福次数

	local level = DataCenter.roleData.level;
	self.lefttipsTxt.text = LanUtil.formateStr(LanUtil.getValue(120819), tostring(Lua_CommonUtil.getNumberTrans(Lua_rewardUtil.getaddexpConfig(level)))); --string.format("%s",Lua_rewardUtil.getaddexpConfig(1).."经验")
	self.leftsurplusnum.text = "[13a100]" .. self.exp_total_count - DataCenter.QiandaoData.exp_count .. "[-][dbe6f5]/" .. self.exp_total_count .. "[-]";
	self.leftcostnum.text = Lua_rewardUtil.getneedmoneyConfig(self.exp_count);

	self.middletipsTxt.text = LanUtil.formateStr(LanUtil.getValue(120820), string.format(Lua_CommonUtil.getNumberTrans(Lua_rewardUtil.addexpConfig(level))));
	self.middlesurplusnum.text = "[13a100]" .. self.money_total_count - DataCenter.QiandaoData.money_count .. "[-][dbe6f5]/" .. self.money_total_count;

	if self.money_time ~= nil and tonumber(self.money_time) <= 0 then
		self.middlemoney:setEnable(false);
		self.middlecostnum.text = LanUtil.formateStr(LanUtil.getValue(120868));
		self.middlecostnum:setLocation(10, -117, 0);
	else
		self.middlemoney:setEnable(true);
		self.middlecostnum.text = Lua_rewardUtil.needmoneyConfig(self.money_count);
		self.middlecostnum:setLocation(50, -117, 0);
	end

	self.righttipsTxt.text = LanUtil.formateStr(LanUtil.getValue(120870), tostring(Lua_CommonUtil.getNumberTrans(Lua_rewardUtil.getAddLifeConfig(level)))); --string.format("%s",Lua_rewardUtil.getaddexpConfig(1).."经验")
	self.rightsurplusnum.text = "[13a100]" .. self.life_total_count - DataCenter.QiandaoData.life_count .. "[-][dbe6f5]/" .. self.life_total_count .. "[-]";
	self.rightcostnum.text = Lua_rewardUtil.getNeedLifeConfig(self.life_count);

	Lua_CommonUtil.addTimer("RightDown", 1, self, self.onRightDown);
	self:onRightDown();
end

function Lua_BlessWindow:onRightDown() --倒计时
	if tonumber(self.money_time) > 0 then
		self.money_time = self.money_time - 1;
		self.middletime.text = LanUtil.formateStr(LanUtil.getValue(120837), TimeTransform.getInstance():transSeconds1(self.money_time, true));
		self.rightredDot:setEnable(false);   
	else
		Lua_CommonUtil.removeTimer(self, self.onRightDown); 
		self.middletime.text = LanUtil.getValue(120825);  
		self.rightredDot:setEnable(true);     
	end
end

function Lua_BlessWindow:blessUpdata()
	for i = 1, self.spArr:getSize() do
		self.spArr[i]:dispose();
	end
	self.spArr:clear();

	self.scaleValue = 0.8;
	self.colorValue = 1;

	-- if self.emptyObj == nil then
		if  self.btnnumber == 0 then
			self.emptyObj = UICreate.createGameObject(self.content, -232, -39, 0);
		elseif self.btnnumber == 1 then
			self.emptyObj = UICreate.createGameObject(self.content, 25, -39, 0);
		else
			self.emptyObj = UICreate.createGameObject(self.content, 282, -39, 0);
		end
	-- end
	-- self.emptyObj.transform.localScale = Vector3(0.8, 0.8, 1);
	LuaUtil.setObjScale(self.emptyObj, 0.8, 0.8, 1);

	local list = {[1] = "ui_common_pz_bj", [2] = "bj_x", [3] = "bj_" .. DataCenter.QiandaoData.multiple};
	local posList = {[1] = - 50, [2] = 15, [3] = 45};
	for i = 1, 3 do
		self.sp = UICreate.createUIAtlasImage(self.emptyObj, "number_atlas", list[i], posList[i], 60, 0, 0);
		if i == 1 then
			self.sp:SetDimensions(103, 51);
		elseif i == 2 then
			self.sp:SetDimensions(30, 32);
		else
			self.sp:SetDimensions(26, 41);
		end
		self.sp:setDepth(15);
		self.spArr:add(self.sp);
	end

	self.bol = false;
	Lua_CommonUtil.addTimer("onBlessCrit", 0.1, self, self.onBlessCrit);
end

function Lua_BlessWindow:onBlessCrit()
	if self.bol == true then
		self.scaleValue = self.scaleValue - 0.2;
		self.colorValue = self.colorValue - 0.2;
		for i = 1, 3 do
			self.spArr[i].uiwidget.color = Color.New(1, 1, 1, self.colorValue);
		end
	else
		self.scaleValue = self.scaleValue + 0.3;
	end

	-- self.emptyObj.transform.localScale = Vector3(self.scaleValue, self.scaleValue, self.scaleValue);
	LuaUtil.setObjScale(self.emptyObj, self.scaleValue, self.scaleValue, self.scaleValue);
	if self.scaleValue > 1.2 then
		self.bol = true;
	end

	if self.scaleValue < 1 then
		Lua_CommonUtil.removeTimer(self, self.onBlessCrit);
		for i = 1, self.spArr:getSize() do
			self.spArr[i]:dispose();
		end
		self.spArr:clear();
	end
end

function Lua_BlessWindow:leftClick()
	if DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.GOLD,Lua_rewardUtil.getneedmoneyConfig(self.exp_count), true, true) == false then  
		return;
	end

	DataCenter.QiandaoData:askBless(0);
	self.btnnumber = 0;
	if self.exprain ~= nil then
		self.exprain:dispose();
	end

	if self.exp_total_count >= self.exp_count then
		self.exprain = UICreate.createUIEffect(self.content, "/effects/scsEffects/exp_rain", "exp_rain", -250, 198);
		self.exprain:SetRenderQueue(self.leftmoney, 3, 2, false);
	end
end

function Lua_BlessWindow:rightClick()
	if tonumber(self.money_time) > 0 then
		if DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.GOLD,Lua_rewardUtil.needmoneyConfig(self.money_count), true, true) == false then  
			return;
		end
	end

	DataCenter.QiandaoData:askBless(1);
	self.btnnumber = 1;
	if self.moneyrain ~= nil then
		self.moneyrain:dispose();
	end

	if self.money_total_count >= self.money_count then
		self.moneyrain = UICreate.createUIEffect(self.content, "/effects/scsEffects/money_rain","money_rain", 0, 198);
		self.moneyrain:SetRenderQueue(self.rightmoney, 3, 2, false);   
	end
end

function Lua_BlessWindow:onMingLiClick()
	local money = DataCenter.moneyData:getMoney(Lua_MoneyData.GOLD) + DataCenter.moneyData:getMoney(Lua_MoneyData.BIND_GOLD);
	if tonumber(DataCenter.moneyData:getMoney(Lua_MoneyData.BIND_GOLD)) < tonumber(Lua_rewardUtil.getNeedLifeConfig(self.life_count)) and
		tonumber(money) >= tonumber(Lua_rewardUtil.getNeedLifeConfig(self.life_count)) then
			local tipData = {};
			tipData.des = LanUtil.getValue(122577);
			tipData.owner = self;
			tipData.subFun = self.onSubCallback;
			tipData.type = 1;
			Lua_WindowUtil.openWin("Lua_TipsWindow", WinParam.ACTION_OPEN, tipData);
	else
		if DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.BIND_GOLD,Lua_rewardUtil.getNeedLifeConfig(self.life_count),true,true) == false then  
			return;
		end
		self:onSubCallback();
	end 
end

function Lua_BlessWindow:onSubCallback()
	DataCenter.QiandaoData:askBless(2);
	self.btnnumber = 2;
	if self.mingliRain ~= nil then
		self.mingliRain:dispose();
	end

	if self.life_total_count >=  self.life_count then
		self.mingliRain = UICreate.createUIEffect(self.content, "/effects/scsEffects/mingli_rain","mingli_rain", 250, 198);
		self.mingliRain:SetRenderQueue(self.rightmoney, 3, 2, false);   
	end
end

function Lua_BlessWindow:dispose()
	Lua_CommonUtil.removeTimer(self,self.onRightDown); 
	Lua_CommonUtil.removeTimer(self, self.onBlessCrit);
	
	self:superCall("dispose");
end