Lua_MondayGiftPanel  = class("Lua_MondayGiftPanel",Lua_DisplayObject);
function Lua_MondayGiftPanel:ctor(p)
	self:superCall("ctor", p, "MondayGiftPanel_skin");
end

function Lua_MondayGiftPanel:buildShowItem(go)
	self:superCall("buildShowItem");

	local item;
	self.rewardList = Array();
	for i = 1, 3 do
		item = Lua_MondayGiftItem.new(self.content);
		item:setLocation(-185 + (i - 1) * 308, -91, 0);
		self.rewardList:add(item);
	end

	self:addLuaEvent("SETMONGIFTDATA",self,self.SetData);
	Lua_MsgUtil.callFunc("SET_REWARDBG_ENABLE", false);
	DataCenter.QiandaoData:GetMonGiftData();
end

function Lua_MondayGiftPanel:SetData(msg)
	local week = os.date("%w", tonumber(tostring(GlobalVar.cur_tick)));
	local temp = 0;
	for i = 1, #msg.info do
		if tonumber(msg.info[i].day) == tonumber(week) then
			temp = i;
		end
	end

	if temp == 0 or #msg.info <= 3 then
		for i = 1, self.rewardList:getSize() do
			if self.rewardList[i] ~= nil then
				local dic = {}
				dic.reward = msg.info[i].reward;
				dic.index = i;
				dic.day = tonumber(msg.info[i].day)
				if tonumber(msg.info[i].state) == 1 then
					dic.state = msg.info[i].state
				elseif i == temp then
					dic.state = 2;
				elseif i < temp then
					dic.state = 3;
				elseif i > temp then
					dic.state = 4;
				end
				self.rewardList[i]:setData(dic);
			end
		end
	else
		local num = 0;
		for i = 1, #msg.info do
			if (tonumber(#msg.info) - i) < 3 and i <= temp or i >= temp then
				num = num + 1
				local dic = {}
				dic.reward = msg.info[i].reward;
				dic.index = num;
				dic.day = tonumber(msg.info[i].day)
				if tonumber(msg.info[i].state) == 1 then
					dic.state = msg.info[i].state
				elseif i == temp then
					dic.state = 2;
				elseif i < temp then
					dic.state = 3;
				elseif i > temp then
					dic.state = 4;
				end
				self.rewardList[num]:setData(dic);
			end

			if num >= 3 then
				break;
			end
		end
	end
end

function Lua_MondayGiftPanel:dispose()
    Lua_MsgUtil.callFunc("SET_REWARDBG_ENABLE", true);
    self:superCall("dispose");
end





--------------------------------------------------





Lua_MondayGiftItem  = class("Lua_MondayGiftItem",Lua_DisplayObject);
function Lua_MondayGiftItem:ctor(p)
	self:superCall("ctor", p, "MondayGiftItem_skin");
end

function Lua_MondayGiftItem:buildShowItem(go)
	self:superCall("buildShowItem");

	self.stateSp:setEnable(false);

	self.rewardItem = Lua_DragList.new(self.content,1, Vector4(0, 0, 260, 210));
	self.rewardItem:setLocation(-3, 25, 0);
	self.rewardItem:setListCell(MondayGiftRewardItem, 90, 87, 3);

	self.getBtn:addClickFuntion(self, self.RewardBtnClick);
end

function Lua_MondayGiftItem:setData(val)
	self.allData = val;

	local day = val.day >= 7 and 0 or val.day;
	self.weekTxt.text = LanUtil.formateStr(LanUtil.getValue(120871 + val.index), LanUtil.getValue(100+day));
	if val.state == 1 then
		self.getBtn:setEnable(false);
		self.getTxt:setEnable(false);
		self.stateSp:setEnable(true);
		self.stateSp:setAltas("common_atlas_1", "ui_common_b_");
	elseif val.state == 2 then
		self.getBtn:setEnable(true);
		self.getTxt:setEnable(true);
		self.getBtn:setAltas("common_atlas_1", "ui_common_btn_02");
		self.getTxt.text = LanUtil.getValue(120813);
		self.stateSp:setEnable(false);
	elseif val.state == 3 then
		self.getBtn:setEnable(false);
		self.getTxt:setEnable(false);
		self.stateSp:setEnable(true);
		self.stateSp:setAltas("common_atlas_1", "ui_common_yicuoguo");
	elseif val.state == 4 then
		self.getBtn:setEnable(true);
		self.getTxt:setEnable(true);
		self.getTxt.text = LanUtil.formateStr(LanUtil.getValue(120876), LanUtil.getValue(100 + day));
		self.getBtn:setAltas("common_atlas_1", "ui_common_btn_01");
		self.stateSp:setEnable(false);
	end

	local arr = Array();
	for i = 1, #val.reward do
		arr:add(val.reward[i]);
	end
	self.rewardItem:setLuaArrayData(arr, false);
end

function Lua_MondayGiftItem:RewardBtnClick()
	local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
	local leftNum = bagData:getLeftSize()
	if leftNum <= 0 then
		DataCenter.packData:showFullBagTip(Lua_PackData.BAG_PACK)
		return;
	end
	DataCenter.QiandaoData:GetMonGiftReward(self.allData.day);
	DataCenter.QiandaoData:GetMonGiftData();
end

function Lua_MondayGiftItem:dispose()
	if self.rewardItem ~= nil then
		self.rewardItem:dispose();
		self.rewardItem = nil;
	end
	self:superCall("dispose");
end





--------------------------------------------------





MondayGiftRewardItem = class("MondayGiftRewardItem",Lua_ListCell)
function MondayGiftRewardItem:ctor(p)
	self:superCall("ctor", p);
end

function MondayGiftRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.item = Lua_ToolImage.new(self.content);
	self.item.item_bg:SetDimensions(74, 74);
	self.item:setDepth(5);
end

function MondayGiftRewardItem:setData(data)
	self.data = data;

	local vo =  Lua_ToolVo.createToolVo(self.data.id,self.data.amout,self.data.bind);
	vo.star = data.star;
	vo.roundEffect = self.data.effect ~= 0 and true or false;
	self.item.data = vo;
end

function MondayGiftRewardItem:checkOutBound(showRect)
	if self.item.roundEff ~= nil then
		local rect = Lua_Rectangle.new(self.itemX, self.itemY-27, 100,70);
		if showRect:containeRect(rect) == true then
			self.item.roundEff:setEnable(true);
		else
			self.item.roundEff:setEnable(false);
		end
	end
end

function MondayGiftRewardItem:dispose()
	self:superCall("dispose");
end