Lua_OnLineRewardPlane  = class("Lua_OnLineRewardPlane",Lua_DisplayObject);
function Lua_OnLineRewardPlane:ctor(p)	
	self:superCall("ctor", p);
end

function Lua_OnLineRewardPlane:buildShowItem(go)	
	self:superCall("buildShowItem");

	self.onlineBg = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_widget_d1", 124, -267, 916, 100);
	self.onlineBg:setDepth(3515);
	self.onlineBg.name = "onlineBg";
	self.onlineBg.clickScale = false;

	self.onlineLab = UICreate.createLabel(self.content, "", -100, -267, 500, 30, 28);
	self.onlineLab:setDepth(3520);
	self.onlineLab.name = "onlineLab";
	self.onlineLab.pivot = UIWidget.Pivot.Left;

	self.OnLineDragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 922, 466));
	self.OnLineDragList:setListCell(Lua_OnLineRewardItem, 135, 926, 1);
	self.OnLineDragList:setLocation(124, 23, 0);

	self:addLuaEvent("GEONLINE_UPDATE", self, self.GetOnLineUpData);
	DataCenter.QiandaoData:getonline();
end

function Lua_OnLineRewardPlane:GetOnLineUpData()
	self.OnLineDragList:setLuaArrayData(DataCenter.QiandaoData.onlinedata, false);

	self.startTime = getTime();
	self:startTimer();
	self:updateOnLineTime();
end

function Lua_OnLineRewardPlane:startTimer()
	if self.countDown ~= true then
		self.countDown = true;
		Lua_CommonUtil.addTimer("Lua_OnLineRewardPlane", 1, self, self.updateOnLineTime);
	end
end

function Lua_OnLineRewardPlane:updateOnLineTime()
	local time = DataCenter.QiandaoData.login_time + getTime() - self.startTime;
	self.onlineLab.text = LanUtil.formateStr(LanUtil.getValue(120838),
		TimeTransform.getInstance():transSeconds15(time, true));
end

function Lua_OnLineRewardPlane:endTimer()
	if self.countDown == true then
		self.countDown = false;
		Lua_CommonUtil.removeTimer(self, self.updateOnLineTime);
	end
end

function Lua_OnLineRewardPlane:dispose()
	if self.onlineBg ~= nil then
		self.onlineBg:dispose();
		self.onlineBg = nil;
	end
	if self.onlineLab ~= nil then
		self.onlineLab:dispose();
		self.onlineLab = nil;
	end
	if self.OnLineDragList ~= nil then
		self.OnLineDragList:dispose();
		self.OnLineDragList = nil;
	end
	self:endTimer();

	self:superCall("dispose");
end





--------------------------------------------------





Lua_OnLineRewardItem = class("Lua_OnLineRewardItem",Lua_ListCell)
function Lua_OnLineRewardItem:ctor(p)	
	self:superCall("ctor", p, "OnLineRewardItemRight_skin");
end

function Lua_OnLineRewardItem:buildShowItem() 
	self:superCall("buildShowItem");

	self.lvLab:setEnable(false);

	self.rewardItem = Lua_RewardItem.new(self.content);
	self.rewardItem:buildShowItem();
	self.rewardItem:setLayout(95, 80, 5);
	self.rewardItem:setDepth(5);
	self.rewardItem:setMaxShow(5);
	self.rewardItem:setClickWin(true);
	self.rewardItem:setMouseEnble(true);
	self.rewardItem:setLocation(-130, 0, 0);

	self.stateBtn:addClickFuntion(self, self.ondrawOnlineRewardClick);
end

function Lua_OnLineRewardItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	self.timetext.text = LanUtil.formateStr(LanUtil.getValue(120812), TimeTransform.getInstance():transSeconds15(data.onlinetime, true));

	local len = #data.count;
	local rewardInfoArr = Array();
	local tvo;
	for i = 1, len do
		tvo = Lua_ToolVo.createToolVo(data.count[i][1], data.count[i][2], data.count[i][3]);
		tvo.star = data.count[i][4];
		tvo.packType = 999;
		if data.isRoundEff[i] == 1 and tvo.color >= 3 then
			tvo.roundEffect = true;
		end
		rewardInfoArr:add(tvo);
	end
	self.rewardItem:setRewardByArray(rewardInfoArr);

	if data.isActive == 1 then 
		self.stateBtn.label = LanUtil.getValue(120813);
	elseif data.isActive == 0 then
		self.stateBtn.label = LanUtil.getValue(120814);
	end

	self.stateBtn:setEnable(data.isActive ~= 2);
	self.stateBtn:setStyle(data.isActive == 1 and 13 or 12);
	self.stateBtn:setMouseEnable(data.isActive == 1);
	self.drawedIcon:setEnable(data.isActive == 2);
	self.redDot:setEnable(data.isActive == 1);
end

function Lua_OnLineRewardItem:checkOutBound(showRect)
	-- local width = self.rewardItem.awords[1].item_bg.width;
	-- local height = self.rewardItem.awords[1].item_bg.height;
	local rect = Lua_Rectangle.new(self.itemX - 75 / 2, self.itemY - 77 / 2, 75, 77);
	local isShowEffect = showRect:containeRect(rect);
	for i = 1, #self.data.isRoundEff do
		self.rewardItem.awords[i]:showRoundEff(isShowEffect and self.data.isRoundEff[i] == 1);
	end
end

function Lua_OnLineRewardItem:ondrawOnlineRewardClick() 
	DataCenter.QiandaoData:online(self.data.index - 1);
end

function Lua_OnLineRewardItem:dispose()
	if self.rewardItem ~= nil then
		self.rewardItem:dispose();
		self.rewardItem = nil;
	end
	self.data = nil;

	self:superCall("dispose");
end