-- 新每日签到
Lua_QianDaoRightPanle  = class("Lua_QianDaoRightPanle",Lua_DisplayObject);
function Lua_QianDaoRightPanle:ctor(p)	
	self:superCall("ctor", p, "QianDaoRewardRight_skin");
end

function Lua_QianDaoRightPanle:buildShowItem()
	self:superCall("buildShowItem");

	self.dragListItems = Array();

	self.barIcon.type = UIBasicSprite.Type.Filled;
	self.barIcon.fillDirection = UIBasicSprite.FillDirection.Horizontal;
	self.barIcon.fillAmount = 0;

	self.signInList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 910, 372));
	self.signInList:setListCell(Lua_QianDaoRightItem, 130, 130, 7);
	self.signInList:setLocation(121, 70, 0);
	
	self.qiandao:addClickFuntion(self, self.retroactiveClick);

	self:addLuaEvent("GETQIANDAO_UPDATE", self, self.getQiandaoUpData);
	DataCenter.QiandaoData:getQiandao();
end

function Lua_QianDaoRightPanle:getQiandaoUpData()
	local qiandaoData = DataCenter.QiandaoData;
	local obj;
	self.signInDay = 0;
	for i = 1, qiandaoData.signInShowArr:getSize() do
		obj = qiandaoData.signInShowArr[i];
		obj.isCanDraw = obj.index == qiandaoData.dat_index; -- 是否可领取
		obj.isDrawed = obj.index == obj.signInIdx; -- 是否已领取
		if obj.index == obj.signInIdx then
			self.signInDay = self.signInDay + 1; -- 累计登录天数
		end
	end
	self.signInList:setLuaArrayData(qiandaoData.signInShowArr, false);

	self.signInRewardArr = qiandaoData.signInRewardArr;
	if self.isFirst ~= true then
		self.isFirst = true;
		self.signInList:moveToIndex(math.ceil(qiandaoData.dat_index / 7), true);
		self:initRewardInfo();
	else
		self.signInList:moveToIndex(math.ceil(qiandaoData.dat_index / 7));
	end

	self.dayLab.text = self.signInDay..LanUtil.getValue(23);
	self.buqianTxt.text = qiandaoData.supplement_number..LanUtil.getValue(23);
	self.qiandao.mouseEnable = qiandaoData.supplement_number > 0;
	self.qiandao:setGray(qiandaoData.supplement_number <= 0);

	for i = 1, qiandaoData.recordSignInArr:getSize() do
		if qiandaoData.recordSignInArr[i].specialIdx ~= 0 then -- 已领取
			self.signInRewardList[i].drawState = false;
			self.signInRewardList[i].itemImg:showRoundEff(false);

			self.signInRewardList[i].maskIcon.alpha = 0.5;
			self.signInRewardList[i].drawIcon:setEnable(true);
		else
			local drawState = self.signInDay >= self.signInRewardArr[i].awardcount;
			self.signInRewardList[i].drawState = drawState;
			self.signInRewardList[i].itemImg:showRoundEff(drawState);

			self.signInRewardList[i].maskIcon.alpha = 0.1;
			self.signInRewardList[i].drawIcon:setEnable(false);
		end
	end
	self:updateShowBar();
end

function Lua_QianDaoRightPanle:initRewardInfo()
	local rewardItem;
	self.signInRewardList = Array();
	self.dayRecordArr = Array();
	for i = 1, self.signInRewardArr:getSize() do
		rewardItem = Lua_SignInRewardItem.new(self.content);
		rewardItem.content.name = "Lua_SignInRewardItem" .. self.signInRewardArr[i].awardcount;
		rewardItem:initData(self.signInRewardArr[i], i);
		rewardItem:setLocation(18 + (i - 1) * 125, -188, 0);
		self.signInRewardList:add(rewardItem);

		self.dayRecordArr:add(self.signInRewardArr[i].awardcount);
	end
end

function Lua_QianDaoRightPanle:updateShowBar()
	local curVal;
	local curShowVal;
	local curMonthRewardCount = DataCenter.QiandaoData.signInShowArr:getSize();
	local preActPoint;
	local nextActPoint;
	local prePoint;
	local len = self.dayRecordArr:getSize();
	local spacing = (self.dayRecordArr[len] - self.dayRecordArr[1]) / (len - 1);
	for i = 1, len do
		if i == 1 then
			curVal = self.signInDay;
			curShowVal = curVal / curMonthRewardCount;
		else
			preActPoint = self.dayRecordArr[i - 1];
			nextActPoint = self.dayRecordArr[i];
			if preActPoint < self.signInDay and self.signInDay <= nextActPoint then
				prePoint = self.dayRecordArr[1] + (i - 2) * spacing;
				curVal = prePoint + (self.signInDay - preActPoint) / (nextActPoint - preActPoint) * spacing;
				curShowVal = curVal / curMonthRewardCount;
				break;
			else
				curVal = self.signInDay;
				curShowVal = curVal / curMonthRewardCount;
			end
		end
	end
	self.barIcon.fillAmount = curShowVal;
end

function Lua_QianDaoRightPanle:retroactiveClick()
	Lua_WindowUtil.openWin("Lua_QiandaoTipsWindow", WinParam.ACTION_OPEN, DataCenter.QiandaoData.supplement_number);
end

function Lua_QianDaoRightPanle:dispose()
	if self.signInList ~= nil then
		self.signInList:dispose();
		self.signInList = nil;
	end
	if self.signInRewardList ~= nil then
		self.signInRewardList:dispose();
		self.signInRewardList:clear();
		self.signInRewardList = nil;
	end

	self:superCall("dispose");
end





--------------------------------------------------





Lua_QianDaoRightItem = class("Lua_QianDaoRightItem",Lua_ListCell);
function Lua_QianDaoRightItem:ctor(p)
	self:superCall("ctor", p, "QianDaoRightItem_skin");
end

function Lua_QianDaoRightItem:buildShowItem()
	self:superCall("buildShowItem");

	self.maskIcon.alpha = 0.5;
	self.maskIcon:setEnable(false);
	self.drawIcon:setEnable(false);

	-- self.itemImage = Lua_ToolImage.new(self.content);
	-- self.itemImage:setDepth(3);
	-- self.itemImage:setCanClick(false);
end

function Lua_QianDaoRightItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	local tvo = Lua_ToolVo.new(data.itemid, data.itemcount, data.itembin);
	-- self.itemImage.data = tvo;
	self.itemIcon:setAltas(tvo.atlas, tvo.referenceId);

	self.itemNumLab.text = data.itemcount;
	self.multipleLab.text = LanUtil.formateStr(LanUtil.getValue(120816), tostring(data.viplvl), tostring(data.vipcount));

	self.multipleBg:setEnable(data.viplvl > 0);
	self.multipleLab:setEnable(data.viplvl > 0);
	self.drawIcon:setEnable(data.isDrawed);
	self.maskIcon:setEnable(data.isDrawed);
	self.selectIcon:setEnable(data.isCanDraw and data.isDrawed == false);
end

-- function Lua_QianDaoRightItem:setCellSeqIndex(idx)
-- 	self:superCall("setCellSeqIndex", idx);

-- 	self.index = (idx - 1) % 7 + 1;
-- 	self.itemBg:setAltas("reward_atlas", "ui_reward_prop_"..self.index);
-- end

function Lua_QianDaoRightItem:onPlayerSoundClick()
	local tvo = Lua_ToolVo.new(self._data.itemid, self._data.itemcount, self._data.itembin);
	if self._data.isCanDraw == true then
		if self._data.isDrawed == true then
			Lua_PackUtil.showItemInfo(tvo);
		else
			if DataCenter.vipData.level >= self._data.viplvl then
				self:onOutClick();
			else
				local name = getConfig({"vip_level", self._data.viplvl, "view_name"})
				Lua_WindowUtil.openWin("Lua_TipsWindow", nil,
				{
					owner = self,
					des = LanUtil.formateStr(LanUtil.getValue(120856), name, tostring(self._data.vipcount)),
					type = 1,
					subName = LanUtil.getValue(120857),
					cancelName = LanUtil.getValue(120858),
					subFun = self.onOutClick,
					cancelFun = self.onSubClick
				});
			end
		end
	else
		Lua_PackUtil.showItemInfo(tvo);
	end
end

function Lua_QianDaoRightItem:onOutClick()
	DataCenter.QiandaoData:askQiandao()
end

function Lua_QianDaoRightItem:onSubClick(go)
	Lua_WindowUtil.openWin("Lua_ChongzhiWindow", nil, 10097);
	Lua_WindowUtil.openWin("Lua_RewardWindow", WinParam.ACTION_CLOSE);
end

-- function Lua_QianDaoRightItem:checkOutBound(showRect)
-- 	if self._data == nil then
-- 		return;
-- 	end

-- 	local width = self.itemIcon.width;
-- 	local height = self.itemIcon.height;
-- 	local rect = Lua_Rectangle.new(self.itemX - width / 2, self.itemY - height / 2, width, height);
-- 	if showRect:containeRect(rect) and self._data.isCanDraw == true and self._data.isDrawed == false then
-- 		if self.effect == nil then
-- 			self.effect = UICreate.createUIEffect(self.content, "/effects/scsEffects/gui_qiandaotubiao", "gui_qiandaotubiao", 0, 0);
-- 			self.effect:SetRenderQueue(self.itemIcon, 1, 2, false);
-- 		end
-- 		self.effect:setEnable(true);
-- 	else
-- 		if self.effect ~= nil then
-- 			self.effect:setEnable(false);
-- 		end
-- 	end
-- end

function Lua_QianDaoRightItem:dispose()
	if self.effect ~= nil then
		self.effect:dispose();
		self.effect = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end





--------------------------------------------------





Lua_SignInRewardItem = class("Lua_SignInRewardItem", Lua_DisplayObject)
function Lua_SignInRewardItem:ctor(p)
	self:superCall("ctor", p, "SignInRewardItem_skin");
end

function Lua_SignInRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.maskIcon.alpha = 0.1;
	self.maskIcon.clickScale = false;
	self.drawIcon:setEnable(false);

	self.itemImg = Lua_ToolImage.new(self.content);
	self.itemImg:setDepth(2);
	self.itemImg:setCanClick(false);

	self.maskIcon:addClickFuntion(self, self.onRewardClick);
end

function Lua_SignInRewardItem:initData(data, index)
	self.data = data;
	self.index = index;

	local rewardInfo = data.rewardshow;
	local cofing = getConfig({"item", rewardInfo[1][1], "subType"});
	if data.career_limit == 1 and cofing == Lua_PackTypeDefine.WING_ITEM then -- 神翼区分职业
		local a = string.sub(rewardInfo[1][1], 1, 2); -- 第1和第2个字符串
		local b = string.sub(rewardInfo[1][1], 4, -1); -- -1是最后一个字符串
		id = tonumber(a..DataCenter.roleData.career..b);
	else
		id = rewardInfo[1][1];
	end
	self.itemImg.data = Lua_ToolVo.createToolVo(id, rewardInfo[1][2], rewardInfo[1][3]);

	self.dayLab.text = data.awardcount..LanUtil.getValue(23)
end

function Lua_SignInRewardItem:onRewardClick()
	if self.drawState == false then
		Lua_PackUtil.showItemInfo(self.itemImg.data);
	else
		DataCenter.QiandaoData:addupQiandao(self.index);
	end
end

function Lua_SignInRewardItem:dispose()
	if self.itemImg ~= nil then
		self.itemImg:dispose();
		self.itemImg = nil;
	end
	self:superCall("dispose");
end